<ng-container *ngIf="vm$ | async as vm">
  <div
    [ngClass]="[jds.tableResponsive]"
    [style.border]="'2px solid #E0E0E0'"
    [style.border-bottom]="'none'"
    [style.border-top-left-radius.px]="16"
    [style.border-top-right-radius.px]="16"
  >
    <table
      [ngClass]="[jds.table, jds.mb(0)]"
      [style.border-collapse]="'separate'"
      [style.border-spacing]="0"
      role="table"
      aria-label="List Ringkasan Urusan"
      aria-describedby="Table List Ringkasan Urusan"
    >
      <thead>
        <tr>
          <th
            [ngClass]="[jds.bg('#E9F2FE')]"
            [style.border]="'1px solid #E0E0E0'"
            [style.border-left]="'none'"
            [style.border-top]="'none'"
            [style.width.px]="42"
          >
            No
          </th>
          <th
            [ngClass]="[jds.bg('#E9F2FE')]"
            [style.border]="'1px solid #E0E0E0'"
            [style.border-top]="'none'"
            [isSortable]="true"
            [currentSort]="{
              sort: filterSort,
              direction: filterDirection
            }"
            (filterSort)="onSort($event)"
            column="kode_bidang_urusan"
            scope="col"
            jdsBiTableHead
          >
            <span [style.white-space]="'nowrap'">Kode Urusan</span>
          </th>
          <th
            [ngClass]="[jds.bg('#E9F2FE')]"
            [style.border]="'1px solid #E0E0E0'"
            [style.border-top]="'none'"
            [style.width.%]="35"
          >
            Bidang Urusan
          </th>
          <th
            [ngClass]="[jds.bg('#E9F2FE')]"
            [style.border]="'1px solid #E0E0E0'"
            [style.border-top]="'none'"
            [style.width.px]="168"
            [isSortable]="true"
            [currentSort]="{
              sort: filterSort,
              direction: filterDirection
            }"
            (filterSort)="onSort($event)"
            column="progress"
            scope="col"
            jdsBiTableHead
          >
            Progress
          </th>
          <th
            [ngClass]="[jds.bg('#E9F2FE')]"
            [style.border]="'1px solid #E0E0E0'"
            [style.border-top]="'none'"
            [isSortable]="true"
            [currentSort]="{
              sort: filterSort,
              direction: filterDirection
            }"
            (filterSort)="onSort($event)"
            column="last_update"
            scope="col"
            jdsBiTableHead
          >
            <span [style.white-space]="'nowrap'">Update Terakhir</span>
          </th>
          <th
            [ngClass]="[jds.bg('#E9F2FE')]"
            [style.border]="'1px solid #E0E0E0'"
            [style.border-right]="'none'"
            [style.border-top]="'none'"
            [colorScheme]="'gray'"
            [colorCustom]="true"
            [isFilterable]="true"
            scope="col"
            jdsBiTableHead
            column="type"
          >
            <span>OPD</span>

            <div
              [style.cursor]="'pointer'"
              filter
              role="button"
            >
              <jds-bi-hosted-dropdown
                [jdsBiDropdownLimitWidth]="'custom'"
                [jdsBiDropdownMinWidth]="240"
                [content]="dropdownFilterOPD"
              >
                <i
                  class="tblhd-icon"
                  [ngClass]="['active']"
                ></i>
              </jds-bi-hosted-dropdown>
            </div>
          </th>
        </tr>
      </thead>
      <tbody>
        <ng-container *ngIf="vm.listUrusanWalidata as listUrusanWalidata">
          <ng-container *ngIf="listUrusanWalidata.isLoading">
            <ng-container *ngTemplateOutlet="loading" />
          </ng-container>
          <ng-container *ngIf="listUrusanWalidata.isSuccess">
            <ng-container *ngIf="listUrusanWalidata.isFetching">
              <ng-container *ngTemplateOutlet="loading" />
            </ng-container>
            <ng-container *ngIf="!listUrusanWalidata.isFetching">
              <ng-container *ngIf="listUrusanWalidata?.data?.list?.length > 0">
                <tr
                  *ngFor="
                    let row of listUrusanWalidata?.data?.list ?? [];
                    let i = index
                  "
                >
                  <td
                    [style.border]="'1px solid #E0E0E0'"
                    [style.border-left]="'none'"
                  >
                    {{
                      vm.paginationParamsBidangUrusanWalidata.perPage *
                        (vm.paginationParamsBidangUrusanWalidata.currentPage -
                          1) +
                        (i + 1)
                    }}
                  </td>
                  <td [style.border]="'1px solid #E0E0E0'">
                    {{ row.kode_bidang_urusan ?? '-' }}
                  </td>
                  <td [style.border]="'1px solid #E0E0E0'">
                    {{ row.nama_bidang_urusan ?? '-' }}
                  </td>
                  <td [style.border]="'1px solid #E0E0E0'">
                    <div
                      [ngClass]="[jds.d('flex'), jds.alignItems('center')]"
                      [style.gap.px]="10"
                    >
                      <div
                        [ngClass]="[jds.progress, jds.h(6)]"
                        [style.width.px]="98"
                      >
                        <div
                          [ngClass]="[jds.progressBar, jds.bg('#1FB767')]"
                          [style.width.%]="row.progress ?? 0"
                          role="progressbar"
                        ></div>
                      </div>
                      <div
                        [ngClass]="jds.fw('bold')"
                        [style.min-width.px]="46"
                      >
                        {{ row.progress?.toString()?.replace('.', ',') ?? 0 }}%
                      </div>
                    </div>
                  </td>
                  <td [style.border]="'1px solid #E0E0E0'">
                    {{
                      row.last_update
                        ? moment(row.last_update).format('DD MMMM YYYY')
                        : '-'
                    }}
                  </td>
                  <td
                    [style.border]="'1px solid #E0E0E0'"
                    [style.border-right]="'none'"
                    [ngClass]="[jds.fw('bold')]"
                  >
                    {{ row.nama_skpd ?? '-' }}
                  </td>
                </tr>
              </ng-container>

              <ng-container
                *ngIf="listUrusanWalidata?.data?.list?.length === 0"
              >
                <ng-container *ngTemplateOutlet="empty" />
              </ng-container>
            </ng-container>
          </ng-container>
        </ng-container>
      </tbody>
    </table>
  </div>
  <ng-container *ngIf="vm.listUrusanWalidata as listUrusanWalidata">
    <ng-container *ngIf="listUrusanWalidata.isSuccess">
      <ng-container *ngIf="listUrusanWalidata?.data?.list?.length > 0">
        <jds-bi-pagination
          [colorScheme]="colorScheme"
          [perPageItems]="perPageItems"
          [pagination]="listUrusanWalidata.data.pagination"
          [perPage]="vm.paginationParamsBidangUrusanWalidata.perPage"
          [page]="vm.paginationParamsBidangUrusanWalidata.currentPage"
          (filterPerPage)="onPerPage($event)"
          (filterPage)="onPageChange($event)"
        />
      </ng-container>
    </ng-container>
  </ng-container>

  <ng-template #dropdownFilterOPD>
    <ng-container *ngIf="vm.skpdMasterData as skpdMasterData">
      <ng-select
        [(ngModel)]="vm.filterSKPD"
        [searchable]="true"
        [clearable]="true"
        [closeOnSelect]="true"
        [items]="skpdMasterData?.data?.list ?? []"
        [loading]="
          skpdMasterData.isSuccess
            ? skpdMasterData.isFetching
            : skpdMasterData.isLoading
        "
        [typeahead]="vm.paginationParamsMasterDataSKPD.searchInput$"
        [searchFn]="disableLocalSearch()"
        (change)="filterSKPD($event)"
        (clear)="filterSKPD(null)"
        bindValue="kode_skpd"
        bindLabel="nama_skpd"
        placeholder="Filter"
        appendTo="body"
      />
    </ng-container>
  </ng-template>

  <ng-template #loading>
    <tr *ngFor="let i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]">
      <td
        [style.border]="'1px solid #E0E0E0'"
        [style.border-left]="'none'"
      >
        <ng-container *ngTemplateOutlet="skeleton" />
      </td>
      <td [style.border]="'1px solid #E0E0E0'">
        <ng-container *ngTemplateOutlet="skeleton" />
      </td>
      <td [style.border]="'1px solid #E0E0E0'">
        <ng-container *ngTemplateOutlet="skeleton" />
      </td>
      <td [style.border]="'1px solid #E0E0E0'">
        <ng-container *ngTemplateOutlet="skeleton" />
      </td>
      <td [style.border]="'1px solid #E0E0E0'">
        <ng-container *ngTemplateOutlet="skeleton" />
      </td>
      <td
        [style.border]="'1px solid #E0E0E0'"
        [style.border-right]="'none'"
      >
        <ng-container *ngTemplateOutlet="skeleton" />
      </td>
    </tr>
  </ng-template>

  <ng-template #empty>
    <tr>
      <td
        [ngClass]="[jds.textAlign('center')]"
        [style.border]="'1px solid #E0E0E0'"
        [style.border-left]="'none'"
        [style.border-right]="'none'"
        colspan="6"
      >
        Ringkasan urusan saat ini belum tersedia.
      </td>
    </tr>
  </ng-template>

  <ng-template #skeleton>
    <div class="wrapper-skeleton">
      <ngx-skeleton-loader
        [theme]="{
          width: '80%',
          'border-radius': '0',
          height: '22px',
          'margin-bottom': '0px'
        }"
      />
    </div>
  </ng-template>
</ng-container>
